﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using CG2.Mathematics;
using CG2.Rendering;

namespace CG2.Lighting
{
	public class PointLight : Light
	{
		#region Properties

		public Vector4 Origin;

		public Double Range = 1; 

		public Double LinearAttenuation = 1.0;
		public Double QuadraticAttenuation = 0.0;

		#endregion

		#region Lighting

		public override Double GetIntensityAt(Vector4 point)
		{
			Vector4 l = Origin - point;
			Double d = l.Length;
			Double range2 = Range*Range;

			return Intensity * Range / (Range + LinearAttenuation * d) * range2 / (range2 + QuadraticAttenuation * d * d); // Blender
			//return Intensity / (ConstantAttenuation + d * (LinearAttenuation + d * QuadraticAttenuation)); // OpenGl
		}

		public override void SetLightRayAt(Vector4 point, Ray ray)
		{
			Vector4 l = Origin - point;
			Double d = l.Length;
			ray.Set(point, (1.0 / d) * l, null, 0, 0);
			ray.HitParam = d;
		}

		#endregion
	}
}
