﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using CG2.Mathematics;
using CG2.Lighting;

namespace CG2.Shading
{
	public class CheckerShader : Shader
	{
		#region Properties
		
		public Shader Shader0; // even material
		public Shader Shader1; // odd material
		public Double CubeSize = 1;

		#endregion


		#region Shading

		public override Vector4 GetColor(Vector4 point, Vector4 normal, Vector4 eyeDir, Vector4 lightDir, Double lightIntensity, Light light)
		{
			Double ics = 1 / CubeSize;
			Int32 i = (Int32)Math.Ceiling(ics * point.X + 0.00001);
			Int32 j = (Int32)Math.Ceiling(ics * point.Y + 0.00001);
			Int32 k = (Int32)Math.Ceiling(ics * point.Z + 0.00001);

			return (((i + j + k) & 1) == 0) ?
				Shader0.GetColor(point, normal, eyeDir, lightDir, lightIntensity, light) :
				Shader1.GetColor(point, normal, eyeDir, lightDir, lightIntensity, light);
		}

		#endregion
	}
}
